//QR code decorder(QD20) Control Class
//This class has base functions based on the manual
//So, if you want to know mode parameter information,
//please refer to the QD20 manual
//
//Programed by Kenichi Ohara, AIST
//2007/08/29 Ver.0.1: Implementation of base functions

#ifndef _QD25BASE_H_
#define _QD25BASE_H_

#include"SerialCom.h"

#include<iostream>
#include<string>

using namespace std;

class QD25Base
{
 private:
  SerialCom com;
  bool SendCommand(char *command);
  bool SendCommand(char *command,char *message);
 public:
  void Initialize(char *dev);
  void Finalize();
  
  //Protocol Setting
  bool SetProtocol(int mode);
  int GetProtocol();

  //BaudRate Setting
  bool SetBaudRate(int mode);
  int GetBaudRate();

  //Set the Data Bit, Parity, Stop bit 
  //If you use this functions, please check the manual to set command
  bool SetCommunicationParameters(char *com);
  int GetCommunicationParameters();

  //Set the Header and Terminator
  bool SetHeaderTerminator(int mode);
  int  GetHeaderTerminator();

  //Set the Buzzer
  bool SetBuzzerMode(int mode);
  int GetBuzzerMode();

  //SoftTrigger
  
  //Set QR Code Read Mode
  bool SetReadMode(int mode);
  int  GetReadMode();

  //Software Trigger
  //If you want to use this command, please set Synchronous mode
  bool SoftTriggerOn();
  bool SoftTriggerOff();

  //Set SyncronousMode
  bool SetSynchronousMode(int mode);
  int  GetSynchronousMode();

  //QR Code Data Receive
  //This command should be called after SoftTrigger Command
  int ReceiveCodeData(char *data);

  //Unread Check 
  bool SetUnreadCheckMode(int mode);
  int  GetUnreadCheckMode();

  //Unread Character
  bool SetUnreadCharacter(char *character);
  int  GetUnreadCharacter();

  //Debode Time
  bool SetDecodeTime(int mode);
  int  GetDecodeTime();

  //Fale Beep Mode
  bool SetFaleBeepMode(int mode);
  int  GetFaleBeepMode();

  //Set Display Mode for Read Data
  bool SetDisplayReadDataMode(int mode);
  int  GetDisplayReadDataMode();

  //Corner Position Output Setting 
  bool SetMarkPositionOutput(int mode);

 protected:
};

#endif
